class ChristmasSpawns expands Mutator
	config(ChristmasSpawns);

// By: Age	

// Stuff that spawn to map.
	
var string MapNamed; // The level name.

struct PropType // Spawned stuff
{
	var() config string TheClassName;
	var() config vector TheVector;
	var() config rotator TheRotator;
	var() config string TheLevel;
	var() config name TheID;
	var() config string TheProperty;
	var() config string TheValue;
	var() config string By;

}; var() config array<PropType> Spawned;

struct SProperty // Properties
{
	var() config name TheName;
	var() config string TheLevel;
	var() config string TheProperty;
	var() config string TheValue;
	var() config name TheID;
	var() config string By;
}; var() config array<SProperty> Properties;	

var() string me,met;

var bool ResetTextures;
var bool MapChange;

var name NameStr;

event PreBeginPlay()
{
	if( MapNamed=="" )
		MapNamed=Caps(Left(Self,InStr(Self, "."))); // Gets current map name.
}

function PostBeginPlay()
{
	SetTimer(2,false);
}

function Timer()
{
	Macros();
}

function Macros()
{
	local int i,iv;
	local int tv,tva;

	local actor spnd;
	local class<actor> trp;
	local actor a,aa;
	
	iv = GetArraySize(ArrayProperty'Spawned'); // Spawned array size.
	tva = GetArraySize(ArrayProperty'Properties'); // Properties array size.

	for(tv=0;tv<tva;tv++)		
	{
		if( MapNamed==Properties[tv].TheLevel ) // If map name matchs.
		{
			foreach allactors(class'actor',a) // Find all actors.
			{
				if(a.group=='NoMe' || a.group=='None') // Find all actors with group/ID 'NoMe' and 'None'.
				{
					if(a.name==Properties[tv].TheName) // If actor name matchs.
					{
						a.SetPropertyText(Properties[tv].TheProperty,Properties[tv].TheValue);
						if(caps(Properties[tv].TheProperty)=="COLLISIONRADIUS")
							a.SetCollisionSize(float(Properties[tv].TheValue),a.collisionheight);
						if(caps(Properties[tv].TheProperty)=="COLLISIONHEIGHT")
							a.SetCollisionSize(a.collisionradius,float(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="BCOLLIDEACTORS")
							a.SetCollision(bool(Properties[tv].TheValue),a.bblockactors,a.bblockplayers);
						if(caps(Properties[tv].TheProperty)=="BBLOCKACTORS")
							a.SetCollision(a.bcollideactors,bool(Properties[tv].TheValue),a.bblockactors);
						if(caps(Properties[tv].TheProperty)=="BBLOCKPLAYERS")
							a.SetCollision(a.bcollideactors,a.bblockplayers,bool(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
						{
							if(caps(Properties[tv].TheValue)=="PHYS_NONE")
								a.SetPhysics(Phys_None);						
							if(caps(Properties[tv].TheValue)=="PHYS_WALKING")
								a.SetPhysics(Phys_Walking);
							if(caps(Properties[tv].TheValue)=="PHYS_FALLING")
								a.SetPhysics(Phys_Falling);
							if(caps(Properties[tv].TheValue)=="PHYS_SWIMMING")
								a.SetPhysics(Phys_Swimming);
							if(caps(Properties[tv].TheValue)=="PHYS_FLYING")
								a.SetPhysics(Phys_Flying);
							if(caps(Properties[tv].TheValue)=="PHYS_ROTATING")
								a.SetPhysics(Phys_Rotating);
							if(caps(Properties[tv].TheValue)=="PHYS_PROJECTILE")
								a.SetPhysics(Phys_Projectile);
							if(caps(Properties[tv].TheValue)=="PHYS_ROLLING")
								a.SetPhysics(Phys_Rolling);
							if(caps(Properties[tv].TheValue)=="PHYS_INTERPOLATING")
								a.SetPhysics(Phys_Interpolating);
							if(caps(Properties[tv].TheValue)=="PHYS_MOVINGBRUSH")
								a.SetPhysics(Phys_MovingBrush);
							if(caps(Properties[tv].TheValue)=="PHYS_SPIDER")
								a.SetPhysics(Phys_Spider);
							if(caps(Properties[tv].TheValue)=="PHYS_TRAILER")
								a.SetPhysics(Phys_Trailer);
						}
						if(caps(Properties[tv].TheProperty)=="BASE") // Attach stuff.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(aa!=None)
								{
									if(aa.group=='NoMe' || aa.group=='None')
									{
										if(aa.Name==NameStr)
											a.SetBase(aa);
									}
									else
									{
										if(aa.group==NameStr)
											a.SetBase(aa);
									}
								}
							}
						}			
						if(caps(Properties[tv].TheProperty)=="ENEMY" && scriptedpawn(a)!=None) // Monsters attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(pawn(aa).group=='NoMe' || pawn(aa).group=='None')
									{
										if(pawn(aa).Name==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
									else
									{
										if(pawn(aa).Group==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="ENEMYFIND" || caps(Properties[tv].TheProperty)=="FINDENEMY" && scriptedpawn(a)!=None) // Monsters smart attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(NameStr=='all')
									{
										if(ScriptedPawn(a).SetEnemy(pawn(aa)))
											ScriptedPawn(a).GotoState('attacking');
									}
									else
									{
										if(pawn(aa).IsA(NameStr))
										{
											if(ScriptedPawn(a).SetEnemy(pawn(aa)))
												ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="INITIALSTATE" || caps(Properties[tv].TheProperty)=="STATE") // Set the state.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							a.gotostate(NameStr);
						}
						if(caps(Properties[tv].TheProperty)=="SMARTSCALE") // A "smart" scale. Collision*DrawScale.
						{
							a.DrawScale=float(Properties[tv].TheValue);
							a.SetCollisionSize(a.default.CollisionRadius*a.DrawScale,a.default.CollisionHeight*a.Drawscale);
							if(Pawn(a)!=None)
							{
								Pawn(a).GroundSpeed=Pawn(a).default.GroundSpeed*Pawn(a).DrawScale;
								Pawn(a).AirSpeed=Pawn(a).default.AirSpeed*Pawn(a).DrawScale;
								Pawn(a).WaterSpeed=Pawn(a).default.WaterSpeed*Pawn(a).DrawScale;
								Pawn(a).Accelrate=Pawn(a).default.Accelrate*Pawn(a).DrawScale;
								Pawn(a).Mass=Pawn(a).default.Mass*Pawn(a).DrawScale;
								Pawn(a).Buoyancy=Pawn(a).default.Buoyancy*Pawn(a).DrawScale;
								Pawn(a).Health=Pawn(a).default.Health*Pawn(a).DrawScale;
								Pawn(a).DamageScaling=Pawn(a).default.DamageScaling*Pawn(a).DrawScale;
							}
						}
						if(caps(Properties[tv].TheProperty)=="BDELETEME" && caps(Properties[tv].TheValue)=="TRUE") // Remove it.
							a.destroy();
					}
				}
				else
				{
					if(a.group==properties[tv].TheID) // Find stuff that has ID.
					{
						a.SetPropertyText(Properties[tv].TheProperty,Properties[tv].TheValue);
						if(caps(Properties[tv].TheProperty)=="COLLISIONRADIUS")
							a.SetCollisionSize(float(Properties[tv].TheValue),a.collisionheight);
						if(caps(Properties[tv].TheProperty)=="COLLISIONHEIGHT")
							a.SetCollisionSize(a.collisionradius,float(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="BCOLLIDEACTORS")
							a.SetCollision(bool(Properties[tv].TheValue),a.bblockactors,a.bblockplayers);
						if(caps(Properties[tv].TheProperty)=="BBLOCKACTORS")
							a.SetCollision(a.bcollideactors,bool(Properties[tv].TheValue),a.bblockactors);
						if(caps(Properties[tv].TheProperty)=="BBLOCKPLAYERS")
							a.SetCollision(a.bcollideactors,a.bblockplayers,bool(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
						{
							if(caps(Properties[tv].TheValue)=="PHYS_NONE")
								a.SetPhysics(Phys_None);						
							if(caps(Properties[tv].TheValue)=="PHYS_WALKING")
								a.SetPhysics(Phys_Walking);
							if(caps(Properties[tv].TheValue)=="PHYS_FALLING")
								a.SetPhysics(Phys_Falling);
							if(caps(Properties[tv].TheValue)=="PHYS_SWIMMING")
								a.SetPhysics(Phys_Swimming);
							if(caps(Properties[tv].TheValue)=="PHYS_FLYING")
								a.SetPhysics(Phys_Flying);
							if(caps(Properties[tv].TheValue)=="PHYS_ROTATING")
								a.SetPhysics(Phys_Rotating);
							if(caps(Properties[tv].TheValue)=="PHYS_PROJECTILE")
								a.SetPhysics(Phys_Projectile);
							if(caps(Properties[tv].TheValue)=="PHYS_ROLLING")
								a.SetPhysics(Phys_Rolling);
							if(caps(Properties[tv].TheValue)=="PHYS_INTERPOLATING")
								a.SetPhysics(Phys_Interpolating);
							if(caps(Properties[tv].TheValue)=="PHYS_MOVINGBRUSH")
								a.SetPhysics(Phys_MovingBrush);
							if(caps(Properties[tv].TheValue)=="PHYS_SPIDER")
								a.SetPhysics(Phys_Spider);
							if(caps(Properties[tv].TheValue)=="PHYS_TRAILER")
								a.SetPhysics(Phys_Trailer);
						}
						if(caps(Properties[tv].TheProperty)=="BASE") // Attach stuff.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(aa!=None)
								{
									if(aa.group=='NoMe' || aa.group=='None')
									{
										if(aa.Name==NameStr)
											a.SetBase(aa);
									}
									else
									{
										if(aa.group==NameStr)
											a.SetBase(aa);
									}
								}
							}
						}			
						if(caps(Properties[tv].TheProperty)=="ENEMY" && scriptedpawn(a)!=None) // Monsters attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(pawn(aa).group=='NoMe' || pawn(aa).group=='None')
									{
										if(pawn(aa).Name==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
									else
									{
										if(pawn(aa).Group==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="ENEMYFIND" || caps(Properties[tv].TheProperty)=="FINDENEMY" && scriptedpawn(a)!=None) // Monsters smart attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(NameStr=='all')
									{
										if(ScriptedPawn(a).SetEnemy(pawn(aa)))
											ScriptedPawn(a).GotoState('attacking');
									}
									else
									{
										if(pawn(aa).IsA(NameStr))
										{
											if(ScriptedPawn(a).SetEnemy(pawn(aa)))
												ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="INITIALSTATE" || caps(Properties[tv].TheProperty)=="STATE") // Set the state.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							a.gotostate(NameStr);
						}
						if(caps(Properties[tv].TheProperty)=="SMARTSCALE") // A "smart" scale. Collision*DrawScale.
						{
							a.DrawScale=float(Properties[tv].TheValue);
							a.SetCollisionSize(a.default.CollisionRadius*a.DrawScale,a.default.CollisionHeight*a.Drawscale);
							if(Pawn(a)!=None)
							{
								Pawn(a).GroundSpeed=Pawn(a).default.GroundSpeed*Pawn(a).DrawScale;
								Pawn(a).AirSpeed=Pawn(a).default.AirSpeed*Pawn(a).DrawScale;
								Pawn(a).WaterSpeed=Pawn(a).default.WaterSpeed*Pawn(a).DrawScale;
								Pawn(a).Accelrate=Pawn(a).default.Accelrate*Pawn(a).DrawScale;
								Pawn(a).Mass=Pawn(a).default.Mass*Pawn(a).DrawScale;
								Pawn(a).Buoyancy=Pawn(a).default.Buoyancy*Pawn(a).DrawScale;
								Pawn(a).Health=Pawn(a).default.Health*Pawn(a).DrawScale;
								Pawn(a).DamageScaling=Pawn(a).default.DamageScaling*Pawn(a).DrawScale;
							}
						}
						if(caps(Properties[tv].TheProperty)=="BDELETEME" && caps(Properties[tv].TheValue)=="TRUE") // Remove it.
							a.destroy();
					}
				}
			}
		}
	}
	
	for(i=0;i<iv;i++) // Spawns.	
	{
		if( MapNamed==Spawned[i].TheLevel )
		{
			trp=class<actor>(dynamicloadobject(Spawned[i].TheClassName,class'class',true));
			if(trp!=None)
			{
				if(trp.default.bStatic==true || trp.default.bNoDelete==true) // If the actor is static...
				{
					if(Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_Standalone)
						spnd=Spawn(class'Actori',,,Spawned[i].TheVector,Spawned[i].TheRotator); // ..make an fake actor for it.
					if(spnd!=None)
					{
						spnd.group=Spawned[i].TheID; // Set the ID.
						if(scriptedpawn(spnd)!=None && SkaarjTrooper(spnd)==None) // Skip trooper or it don't get the weapon.
							scriptedpawn(spnd).gotostate('waiting'); // Server may crash/lag if we don't do this.
						if(trp!=None)
							initfor(spnd,trp);
					}
				}
				else
				{
					if(Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_Standalone)
						spnd=Spawn(class<actor>(dynamicloadobject(Spawned[i].TheClassName,class'class')),,,Spawned[i].TheVector,Spawned[i].TheRotator);
					if(spnd!=None)
					{
						spnd.group=Spawned[i].TheID; // Set the ID.
						if(scriptedpawn(spnd)!=None && SkaarjTrooper(spnd)==None) // Skip trooper or it don't get the weapon.
							scriptedpawn(spnd).gotostate('waiting'); // Server may crash/lag if we don't do this.
					}
				}
			}
		}
	}
	
	for(tv=0;tv<tva;tv++) // Double properties check: for spawned actors.	
	{
		if( MapNamed==Properties[tv].TheLevel ) // If map name matchs.
		{
			foreach allactors(class'actor',a) // Find all actors.
			{
				if(a.group=='NoMe' || a.group=='None') // Find all actors with group 'NoMe' and 'None'.
				{
					if(a.name==Properties[tv].TheName) // If actor name matchs.
					{
						a.SetPropertyText(Properties[tv].TheProperty,Properties[tv].TheValue);
						if(caps(Properties[tv].TheProperty)=="COLLISIONRADIUS")
							a.SetCollisionSize(float(Properties[tv].TheValue),a.collisionheight);
						if(caps(Properties[tv].TheProperty)=="COLLISIONHEIGHT")
							a.SetCollisionSize(a.collisionradius,float(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="BCOLLIDEACTORS")
							a.SetCollision(bool(Properties[tv].TheValue),a.bblockactors,a.bblockplayers);
						if(caps(Properties[tv].TheProperty)=="BBLOCKACTORS")
							a.SetCollision(a.bcollideactors,bool(Properties[tv].TheValue),a.bblockactors);
						if(caps(Properties[tv].TheProperty)=="BBLOCKPLAYERS")
							a.SetCollision(a.bcollideactors,a.bblockplayers,bool(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_NONE")
								a.SetPhysics(Phys_None);						
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_WALKING")
								a.SetPhysics(Phys_Walking);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_FALLING")
								a.SetPhysics(Phys_Falling);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_SWIMMING")
								a.SetPhysics(Phys_Swimming);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_FLYING")
								a.SetPhysics(Phys_Flying);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_ROTATING")
								a.SetPhysics(Phys_Rotating);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_PROJECTILE")
								a.SetPhysics(Phys_Projectile);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_ROLLING")
								a.SetPhysics(Phys_Rolling);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_INTERPOLATING")
								a.SetPhysics(Phys_Interpolating);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_MOVINGBRUSH")
								a.SetPhysics(Phys_MovingBrush);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_SPIDER")
								a.SetPhysics(Phys_Spider);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_TRAILER")
								a.SetPhysics(Phys_Trailer);
						if(caps(Properties[tv].TheProperty)=="BASE") // Attach stuff.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(aa!=None)
								{
									if(aa.group=='NoMe' || aa.group=='None')
									{
										if(aa.Name==NameStr)
											a.SetBase(aa);
									}
									else
									{
										if(aa.group==NameStr)
											a.SetBase(aa);
									}
								}
							}
						}			
						if(caps(Properties[tv].TheProperty)=="ENEMY" && scriptedpawn(a)!=None) // Monsters attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(pawn(aa).group=='NoMe' || pawn(aa).group=='None')
									{
										if(pawn(aa).Name==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
									else
									{
										if(pawn(aa).Group==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="ENEMYFIND" || caps(Properties[tv].TheProperty)=="FINDENEMY" && scriptedpawn(a)!=None) // Monsters smart attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(NameStr=='all')
									{
										if(ScriptedPawn(a).SetEnemy(pawn(aa)))
											ScriptedPawn(a).GotoState('attacking');
									}
									else
									{
										if(pawn(aa).IsA(NameStr))
										{
											if(ScriptedPawn(a).SetEnemy(pawn(aa)))
												ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="INITIALSTATE" || caps(Properties[tv].TheProperty)=="STATE") // Set the state.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							a.gotostate(NameStr);
						}
						if(caps(Properties[tv].TheProperty)=="SMARTSCALE") // Set "smart" scale. Collision*DrawScale.
						{
							a.DrawScale=float(Properties[tv].TheValue);
							a.SetCollisionSize(a.default.CollisionRadius*a.DrawScale,a.default.CollisionHeight*a.Drawscale);
							if(Pawn(a)!=None)
							{
								Pawn(a).GroundSpeed=Pawn(a).default.GroundSpeed*Pawn(a).DrawScale;
								Pawn(a).AirSpeed=Pawn(a).default.AirSpeed*Pawn(a).DrawScale;
								Pawn(a).WaterSpeed=Pawn(a).default.WaterSpeed*Pawn(a).DrawScale;
								Pawn(a).Accelrate=Pawn(a).default.Accelrate*Pawn(a).DrawScale;
								Pawn(a).Mass=Pawn(a).default.Mass*Pawn(a).DrawScale;
								Pawn(a).Buoyancy=Pawn(a).default.Buoyancy*Pawn(a).DrawScale;
								Pawn(a).Health=Pawn(a).default.Health*Pawn(a).DrawScale;
								Pawn(a).DamageScaling=Pawn(a).default.DamageScaling*Pawn(a).DrawScale;
							}
						}
						if(caps(Properties[tv].TheProperty)=="BDELETEME" && caps(Properties[tv].TheValue)=="TRUE") // Remove it.
							a.destroy();
					}
				}
				else
				{
					if(a.group==properties[tv].TheID)
					{
						a.SetPropertyText(Properties[tv].TheProperty,Properties[tv].TheValue);
						if(caps(Properties[tv].TheProperty)=="COLLISIONRADIUS")
							a.SetCollisionSize(float(Properties[tv].TheValue),a.collisionheight);
						if(caps(Properties[tv].TheProperty)=="COLLISIONHEIGHT")
							a.SetCollisionSize(a.collisionradius,float(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="BCOLLIDEACTORS")
							a.SetCollision(bool(Properties[tv].TheValue),a.bblockactors,a.bblockplayers);
						if(caps(Properties[tv].TheProperty)=="BBLOCKACTORS")
							a.SetCollision(a.bcollideactors,bool(Properties[tv].TheValue),a.bblockactors);
						if(caps(Properties[tv].TheProperty)=="BBLOCKPLAYERS")
							a.SetCollision(a.bcollideactors,a.bblockplayers,bool(Properties[tv].TheValue));
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_NONE")
								a.SetPhysics(Phys_None);						
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_WALKING")
								a.SetPhysics(Phys_Walking);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_FALLING")
								a.SetPhysics(Phys_Falling);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_SWIMMING")
								a.SetPhysics(Phys_Swimming);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_FLYING")
								a.SetPhysics(Phys_Flying);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_ROTATING")
								a.SetPhysics(Phys_Rotating);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_PROJECTILE")
								a.SetPhysics(Phys_Projectile);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_ROLLING")
								a.SetPhysics(Phys_Rolling);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_INTERPOLATING")
								a.SetPhysics(Phys_Interpolating);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_MOVINGBRUSH")
								a.SetPhysics(Phys_MovingBrush);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_SPIDER")
								a.SetPhysics(Phys_Spider);
						if(caps(Properties[tv].TheProperty)=="PHYSICS")
							if(caps(Properties[tv].TheValue)=="PHYS_TRAILER")
								a.SetPhysics(Phys_Trailer);
						if(caps(Properties[tv].TheProperty)=="BASE") // Attach stuff.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(aa!=None)
								{
									if(aa.group=='NoMe' || aa.group=='None')
									{
										if(aa.Name==NameStr)
											a.SetBase(aa);
									}
									else
									{
										if(aa.group==NameStr)
											a.SetBase(aa);
									}
								}
							}
						}			
						if(caps(Properties[tv].TheProperty)=="ENEMY" && scriptedpawn(a)!=None) // Monsters attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(pawn(aa).group=='NoMe' || pawn(aa).group=='None')
									{
										if(pawn(aa).Name==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
									else
									{
										if(pawn(aa).Group==NameStr)
										{
											ScriptedPawn(a).SetEnemy(pawn(aa));
											ScriptedPawn(a).Enemy=pawn(aa);
											ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="ENEMYFIND" || caps(Properties[tv].TheProperty)=="FINDENEMY" && scriptedpawn(a)!=None) // Monsters smart attack.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							foreach allactors(class'actor',aa)
							{
								if(pawn(aa)!=None)
								{
									if(NameStr=='all')
									{
										if(ScriptedPawn(a).SetEnemy(pawn(aa)))
											ScriptedPawn(a).GotoState('attacking');
									}
									else
									{
										if(pawn(aa).IsA(NameStr))
										{
											if(ScriptedPawn(a).SetEnemy(pawn(aa)))
												ScriptedPawn(a).GotoState('attacking');
										}
									}
								}
							}
						}
						if(caps(Properties[tv].TheProperty)=="INITIALSTATE" || caps(Properties[tv].TheProperty)=="STATE") // Set the state.
						{
							SetPropertyText("NameStr",Properties[tv].TheValue);
							a.gotostate(NameStr);
						}
						if(caps(Properties[tv].TheProperty)=="SMARTSCALE") // Set "smart" scale. Collision*DrawScale.
						{
							a.DrawScale=float(Properties[tv].TheValue);
							a.SetCollisionSize(a.default.CollisionRadius*a.DrawScale,a.default.CollisionHeight*a.Drawscale);
							if(Pawn(a)!=None)
							{
								Pawn(a).GroundSpeed=Pawn(a).default.GroundSpeed*Pawn(a).DrawScale;
								Pawn(a).AirSpeed=Pawn(a).default.AirSpeed*Pawn(a).DrawScale;
								Pawn(a).WaterSpeed=Pawn(a).default.WaterSpeed*Pawn(a).DrawScale;
								Pawn(a).Accelrate=Pawn(a).default.Accelrate*Pawn(a).DrawScale;
								Pawn(a).Mass=Pawn(a).default.Mass*Pawn(a).DrawScale;
								Pawn(a).Buoyancy=Pawn(a).default.Buoyancy*Pawn(a).DrawScale;
								Pawn(a).Health=Pawn(a).default.Health*Pawn(a).DrawScale;
								Pawn(a).DamageScaling=Pawn(a).default.DamageScaling*Pawn(a).DrawScale;
							}
						}
						if(caps(Properties[tv].TheProperty)=="BDELETEME" && caps(Properties[tv].TheValue)=="TRUE") // Remove it.
							a.destroy();
					}
				}
			}
		}
	}
	
//	Log("*********************************************************");
//	Log("*********************************************************");
//	AppSeconds(Time);
//	Log("Christmas spawner successfully edited the map"@"("$mapnamed$") in time ["$Time$"]");
//	Log("*********************************************************");
//	Log("*********************************************************");
}

// Init stuff.
function InitFor(actor Other1, class<actor> Other)
{
	if(Other!=None)
	{
		Other1.DrawScale = Other.default.DrawScale;
		Other1.bMeshCurvy = Other.default.bMeshCurvy;	
		Other1.bMeshEnviroMap = Other.default.bMeshEnviroMap;	
		Other1.Mesh = Other.default.Mesh;
		Other1.Skin = Other.default.Skin;
		Other1.MultiSkins[0] = Other.default.MultiSkins[0];
		Other1.MultiSkins[1] = Other.default.MultiSkins[1];
		Other1.MultiSkins[2] = Other.default.MultiSkins[2];
		Other1.MultiSkins[3] = Other.default.MultiSkins[3];
		Other1.MultiSkins[4] = Other.default.MultiSkins[4];
		Other1.MultiSkins[5] = Other.default.MultiSkins[5];
		Other1.MultiSkins[6] = Other.default.MultiSkins[6];
		Other1.MultiSkins[7] = Other.default.MultiSkins[7];
		Other1.Texture = Other.default.Texture;
		Other1.Sprite = Other.default.Sprite;
		Other1.Fatness = Other.default.Fatness;
		Other1.AnimSequence = Other.default.AnimSequence;
		Other1.SetCollisionSize(Other.default.CollisionRadius,Other.default.CollisionHeight);
		Other1.SetCollision(Other.default.bCollideActors,Other.default.bBlockActors,Other.default.bBlockPlayers);
		Other1.bCollideWorld=Other.default.bCollideWorld;
		Other1.bProjTarget=Other.default.bProjTarget;
		Other1.LightBrightness=Other.default.LightBrightness;
		Other1.LightHue=Other.default.LightHue;
		Other1.LightSaturation=Other.default.LightSaturation;
		Other1.LightRadius=Other.default.LightRadius;
		Other1.LightType=Other.default.LightType;
		Other1.LightEffect=Other.default.LightEffect;
		Other1.LightCone=Other.default.LightCone;
		Other1.DrawType=Other.default.DrawType;
		Other1.bParticles=Other.default.bParticles;
		Other1.Style=Other.default.Style;
		Other1.ActorGUnlitColor=Other.default.ActorGUnlitColor;
		Other1.ActorRenderColor=Other.default.ActorRenderColor;
	}
}

defaultproperties
{
				DrawScale=0.000000
}
